stages:
  - deploy

deploy-job:
  stage: deploy
  image: docker:20.10.16
  services:
    - docker:dind
  variables:
    DOCKER_DRIVER: overlay2
    IMAGE_NAME: "my-front"
  before_script:
    - apk update && apk add openssh-client
  script:
    - echo "$SSH_PRIVATE_KEY" > ssh_key
    - chmod 600 ssh_key
    - ssh -o StrictHostKeyChecking=no -i ssh_key "$USER_SERVER@SERVER_IP" "echo connected"
    - docker build --build-arg VITE_BASE_URL="$VITE_BASE_URL" -t "$IMAGE_NAME:$CI_COMMIT_SHA" .
    - docker save "$IMAGE_NAME:$CI_COMMIT_SHA" | ssh -i ssh_key "$USER_SERVER@SERVER_IP" "docker load"
    - ssh -i ssh_key "$USER_SERVER@SERVER_IP" "docker container rm -f $IMAGE_NAME || true"
    - ssh -i ssh_key "$USER_SERVER@SERVER_IP" "docker run -d --restart always --name $IMAGE_NAME -p 80:80 $IMAGE_NAME:$CI_COMMIT_SHA"